///////////////////////////////////////////////////////////////////////////////////
//Aufgabe 5 aus Kapitel Simulation
/////////////////////////////////////////////////////////////////////
int anzahlBodenRaketen = 72;
int anzahlHoehenRaketen = 4;
float vergluehen = 0;
PImage img;
ArrayList<Rakete> raketen = new ArrayList<Rakete>();
ArrayList<Rakete> neueRaketen = new ArrayList<Rakete>();
ArrayList<Rakete> loescheRaketen = new ArrayList<Rakete>();

void setup() {
  size(1000, 800);
  background(0);
  img = get();
  for (int i=0; i<anzahlBodenRaketen; i++) {
    float v_x = random(-2, 2);
    float v_y = random(-8, -7);   
    color farbe = color(0, random(100, 255), 255);
    raketen.add(new Rakete(width/2+(int)random(-10, 10), height-10, v_x, v_y, 3.0, 0, true, farbe));
  }
} 

void draw() {
  neueRaketen.clear();
  loescheRaketen.clear();
  
  //Bild wird langsam  schwarz  
  vergluehen += 0.02;
  tint(255, vergluehen);
  image(img, 0, 0);
  
  for (Rakete rakete : raketen) {
    rakete.aktualisieren();     
    rakete.display();    
    // wenn Bodenrakete im Zenit erzeuge Höhenraketen
    if (rakete.vomBoden && (rakete.v_y > -0.5) && (rakete.v_y < 0.5)) {
      for (int j = 0; j< 4; j++)
        neueRaketen.add(new Rakete(rakete.x, rakete.y, random(-2, 2), random(-4, 2), 3.0, 255.0, false, 
          color(255, 0, random(0, 255))));
      // markiere Rakete für Löschen    
      loescheRaketen.add(rakete);
    }
  }
  // addiere alle Raketen aus "neueRaketen"
  raketen.addAll(neueRaketen);
  // lösche alle Raketen aus "loescheRaketen"
  raketen.removeAll(loescheRaketen);
}

void keyPressed() { 
  save("tmp.jpg");
}